unit Poyta;
{
   Pyt-komponentti, jonka pll on pytpakkoja. Pyt osaa selata
   pakkojaan.

  5.11.1997/ Tanja Partanen ja Niina Riikonen

  Muutoksia 7.11.1997/vl
   + poista_merkkinnat nimetty poista_merkinta
}

interface

uses
{$ifdef CLX}
  SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QExtCtrls,Kortti,Pakka,Poytap;
{$else}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls,Kortti,Pakka,Poytap;
{$endif}

type TMethPakka  = procedure (p:TPakka) of object;

type
  TPoyta = class(TPanel)
  private
  protected
  public
    constructor Create(AOwner:TComponent);             override;
    procedure ForEveryPakka(proc:TMethPakka);         virtual;
  published
  end;

procedure Register;

implementation

constructor TPoyta.Create(AOwner:TComponent);
begin
  inherited;
  Align    := alRight;
  Caption  := ' ';
end;


procedure TPoyta.ForEveryPakka(proc:TMethPakka);
var i:integer;
var apu:TControl;
begin
  for i:= 0 to ControlCount-1 do begin
    apu := Controls[i];
    if not( apu is TPakka ) then continue;
    proc(apu as TPakka);
  end;
end;

procedure Register;
begin
  RegisterComponents('GKO', [TPoyta]);
end;

end.
