unit hullufinal;
{ Ohjelma joka pelaa Hullupasianssia, tapahtumanksittelyesimerkki
  Tss versiossa peli ei mene lpi, jos knnetn 7.

  Vesa Lappalainen 11.11.1997

  Vaikeinta oli pelin katkeamisen ilmoittaminen.  Vaihtoehtoja:

  1) Otetaan arvo talteen ennen uuden kortin jakamista.
     Laitetaan kortti liikkeelle ja sitten tarkistetaan
     arvo kortin liikkuessa.
     Toimii!
  2) Ksitelln tapahtuma uuden kortin saapuessa kntpakkaan.
     Tarkistetaan uuden kortin arvo.  Jos 7, laitetaan nyttn
     viesti tst.
     Ei toimi, Pakka hvi tilapisesti nkyvist!
     Koska kortin liikkuminen tapahtuu timerin avulla ja kortin saapuessa
     perille, suoritetaan kntpakassa koodia lisaa_paikkaan
     ja koodin lopussa vaihdetaan kortin omistajaksi kntpakka,
     aiheutuu tst kortille ja pakalle WM_PAINT-viesti, joka menee
     viestijonoon.  lisaa_paikkaan lhett lopuksi OnInsert
     tapahtuman, joka kytnnss kutsuu lomakkeen KaantoPakkaInsert-
     metodia, suoritetaan em. metodi edelleen kntpakan alaisuudessa.
     Tm metodi pttyy mahdollisesti ShowMessage-kutsuun, joka modaalisena
     est enemmn kntpakan metodien kutsumisen. Nin j kntpakasta
     WM_PAINT-ksittelemtt, kunnes modaalinen ShowMessage suljetaan.
     Tmn aikaa pakka on nkymttmiss.
     Lisksi kaikki kortit jotka ehditty painaa liikkeelle ennen
     "virheellisen" kortin saapumista, lentvt perille ja peittvt
     virheellisen kortin nkyvist.
  3) Ksitelln tapahtuma JakoPakan antaessa kortin.  Jos peli menee
     poikki, nytetn viesti. Vaikka JakoPakka on laittanut siirron
     jo kyntiin, pyshtyy kortti silti "lhtkuoppiin", sill
     modaalisuus est taas viestien suorittamisen.  Jos kortti komennetaan
     kntymn ennen ShowMessagea, kortti ei knny aina!
         Ylimrisi kortteja ei pse lentoon!
   Korjauksia:
   1)    On hyv sellaisenaan.
   2) a) Viivstetn ShowMessagea kunnes kaikki viestit ksitelty.
         Valitettavasti tm ei onnistunut Application.ProcessMessages
         -kutsulla, vaikka periaatteessa tm olisi voinut toimia.
      b) Viivstetn ShowMessagea pistmll viestijonon viimeiseksi
         viesti, joka kskee nyttmn ShowMessage-dialogin.
         Tm voidaan tehd esim. PostMessage ja tekemll sitten oma
         ksittelij Windows-API -viestille.
         Tllin KntPakka piirt itsens uudelleen ja "viallinen"
         kortti on nkyvill.
         Tmkn ei korjaa monen lentvn kortin ongelmaa!
      c) b)-kohta voidaan tehd aavistuksen helpommaksi tekemll oma
         luokka viivstyksen tekemiselle ja hoitamalla viivstetty kutsu
         tt kautta (ks. EventMsg.pas).
   3) Kuten 2)
         Ylimrisi kortteja ei pse lentoon!
         "Viallinenkin" kortti lent KntPakkaan virheilmoituksen
         aikana.

   Muutokset:
      7.5.2004 / Miika Nurminen
        - pelin loppu yhteen funktioon, uuden pelin kysyminen
        - jakopakan tytt timerilla, pelin lpimeno, tilamuuttuja
        - lukko lopetusdialogiin
}
interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Pakka, APakka, ExtCtrls, Menus, Kortti, EventMsg, Raahausp,
  laskuri;

const WM_SHOWPROBLEM = WM_USER + 13;                                       // b)

type
  TTarkastus = (kylla,ei,jatko);

  TFormHullu = class(TForm)
    KaantoPakka: TRaahausPakka;
    JakoPakka: TAJakoPakka;
    ButtonAnnaKortti: TButton;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Exit1: TMenuItem;
    Laskuri1: TLaskuri;
    CardTimer: TTimer;
    ButtonPlay: TButton;
    AutoTimer: TTimer;
    procedure ButtonAnnaKorttiClick(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure JakoPakkaFull(sender: TPakka; i: Integer; k: TKortti);
    procedure FormCreate(Sender: TObject);
    procedure KaantoPakkaInsert(sender: TPakka; i: Integer; k: TKortti);
    procedure JakoPakkaTake(sender: TPakka; i: Integer; k: TKortti);
    procedure CardTimerTimer(Sender: TObject);
    procedure ButtonPlayClick(Sender: TObject);
    procedure AutoTimerTimer(Sender: TObject);
  private
    state:TTarkastus;
    lock:boolean; // varmistetaan, ettei tule montaa dialogia
    { Private declarations }
    procedure OnStop(o:TObject);                                           // c)
        // viestinksittelymetodin nimell ei ole vli, vain messagen mritteell
    procedure WmShowProb(var Message: TMessage); message WM_SHOWPROBLEM;// b)

    procedure PeliLoppu;
    procedure UusiPeli;
    procedure Tarkasta(k:TKortti); // tarkastetaan, onko peli mennyt lpi
  public
    { Public declarations }
  end;

var
  FormHullu: TFormHullu;

implementation
{$R *.DFM}

procedure TFormHullu.Tarkasta(k: TKortti);
begin
  if (JakoPakka.kortteja=0) then state:=kylla else
  if (Laskuri1.Count=k.Arvo) then state:=ei
  else state:=jatko;
end;

procedure TFormHullu.ButtonAnnaKorttiClick(Sender: TObject);
var i : integer;k:TKortti;
begin
  Laskuri1.Inc(1);
  if (Laskuri1.Count>13) then Laskuri1.Count:=1;

  i := JakoPakka.anna_arvo;
  k:=JakoPakka.anna_kortti;
  if Assigned(k) then //Exit; // <-- poistutaan heti aliohjelmasta
  KaantoPakka.lisaa_kortti(k);
  Tarkasta(k);
//  if (state<>jatko) then PeliLoppu; // 1) OK!
    // uuden pelin aloitus ilman timeria ei onnistu, jos kortti on "matkalla"
end;

procedure TFormHullu.Exit1Click(Sender: TObject);
begin
  Close;
end;

procedure TFormHullu.New1Click(Sender: TObject);
begin
  UusiPeli;
end;

procedure TFormHullu.JakoPakkaFull(sender: TPakka; i: Integer; k: TKortti);
begin
  JakoPakka.sekoita;
end;

procedure TFormHullu.FormCreate(Sender: TObject);
begin
  Randomize;
  JakoPakka.sekoita;
  state:=jatko;
end;

procedure TFormHullu.OnStop(o:TObject);                                    // c)
begin
  PeliLoppu;
end;

procedure TFormHullu.KaantoPakkaInsert(sender: TPakka; i: Integer; k: TKortti);
// dialogeja voi tulla nkyviin useita
begin
//     Peliloppu                 // 2 ongelma
//    PostMessage(Handle,WM_SHOWPROBLEM,0,0);        // 2 b)
 //   DoPostEvent(self,OnStop,k);                    // 2 c)
end;


procedure TFormHullu.JakoPakkaTake(sender: TPakka; i: Integer; k: TKortti);
  // vanhoja kortteja voi jd pakkaan aloitettaessa uutta peli.
begin
  k.Nakyy := kuva;
//    Peliloppu                // 3 ongelma
//    PostMessage(Handle,WM_SHOWPROBLEM,0,0);        // 3 b)
    DoPostEvent(self,OnStop,k);                    // 3 c)
end;

procedure TFormHullu.WmShowProb(var Message: TMessage);                 // b)
begin
  PeliLoppu;
end;


procedure TFormHullu.PeliLoppu;
var res:integer;
begin
  if lock then Exit; // varmistetaan, ettei dialogia kutsuta moneen kertaan
  lock := true;
  res:=IDCANCEL;
  case state of
    jatko:begin
      lock:=false; // HUOM
      Exit;
    end;
    ei:res:=Application.MessageBox('Ei mennyt lpi. Haluatko uuden pelin?','Peli loppu',MB_YESNOCANCEL);
    kylla:res:=Application.MessageBox('Peli lpi. Haluatko uuden pelin?','Peli loppu',MB_YESNO);
  end;
  case res of
    IDYES:UusiPeli;
    IDNO:Close;
  end;
  lock := false;
  state:=jatko;
end;

procedure TFormHullu.UusiPeli;
begin
// nopea ratkaisu, yksittiset kortit eivt ny
// JakoPakka.siirra(Kaantopakka);

  // huom. kortteja ei piirret silmukan aikana, koska paint-tapahtumia ei suoriteta tapahtuman aikana.
     // seuraus: pakka "katoaa" korttien mrst riippuvaksi ajaksi

  (* // EI NIN.
    while (Kaantopakka.kortteja>0) do begin
    Sleep(100); // ilman tt nyttisi yhdelt kortilta
    JakoPakka.lisaa_kortti(Kaantopakka.anna_kortti);
  end;*)

  //timerpohjainen toteutus
  CardTimer.Enabled:=true;
  state:=jatko;
end;



procedure TFormHullu.CardTimerTimer(Sender: TObject);
begin
  if (kaantopakka.kortteja>0) then
    JakoPakka.lisaa_kortti(Kaantopakka.anna_kortti)
  else begin
    CardTimer.Enabled:=false;
  end;
end;

procedure TFormHullu.ButtonPlayClick(Sender: TObject);
begin
  AutoTimer.Enabled:=true;
end;

procedure TFormHullu.AutoTimerTimer(Sender: TObject);
begin
  if (state=jatko) then ButtonAnnaKortti.Click
  else AutoTimer.Enabled:=false;
end;

end.
