unit Poytap;
{
  Pytpakka-komponentti:
  - Pakka, jolla on mys CheckBox, joten se voidaan merkit.

  5.11.1997/ Tanja Partanen ja Niina Riikonen

  Muutoksia 7.11.1997/vl
    + anna_kortin OnClickin muuttaminen inherited jlkeen
  Muutoksia 27.8.2001/vl
    + otettu huomioon pakan muutokset, eli jo pakkaa
      voi klikata
    + peritty suoraan raahauspakasta, jolloin ei tarvitse kirjoittaa
      niin paljoa koodia
}

interface

uses
{$ifdef CLX}
  SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QExtCtrls, QStdCtrls,Kortti,Pakka,APakka,Raahausp;
{$else}
  SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls,Kortti,Pakka,APakka,Raahausp;
{$endif}

type
  TPoytap = class(TRaahausPakka)
  private
    FActive      : boolean;
    FCheckBox    : TCheckBox;
  protected
  public
    constructor Create(AOwner:TComponent);    override;
    destructor  Destroy;                      override;
    function    GetChecked:Boolean;             virtual;
    procedure   SetChecked(check:Boolean);      virtual;
    procedure   SetActive(a:Boolean);         virtual;
    function    Kelpaako(k:TKortti):boolean;  override;
    procedure PakkaClick(Sender: TObject); override;
  published
    property  Checked:Boolean read GetChecked write SetChecked;
    property  Active:Boolean  read FActive write SetActive;
end;

procedure Register;

implementation


constructor TPoytaP.Create(AOwner:TComponent);
begin
  Inherited;
  Height   := 100;
  Width    := 73;
  FCheckBox := TCheckBox.Create(self);
  if ( FCheckBox = NIL ) then exit;
  FCheckBox.Parent    := self;
//KYLIX  FCheckBox.Alignment := taRightJustify;
  FCheckBox.Left      := 4;
  FCheckBox.Top       := Height;
  FCheckBox.Checked   := False;
  Checked             := False;
  Active              := True;
//  OnDragDrop          :
end;

destructor  TPoytap.Destroy;
begin
  FCheckBox.Free;
  inherited;
end;


procedure TPoytap.SetActive(a:Boolean);
begin
  FActive := a;             
//  Visible := a and (kortteja > 0);                                         // vl
end;

procedure TPoytap.SetChecked(check:Boolean);
begin
  FCheckBox.Checked := check;
end;

function TPoytap.GetChecked:Boolean;
begin
  result := FCheckbox.Checked;
end;

procedure TPoytap.PakkaClick(Sender: TObject);
begin
  inherited;
  Checked := not Checked;
end;

function TPoytap.Kelpaako(k:TKortti):boolean;
begin
  Result := kortteja = 0;
end;



procedure Register;
begin
  RegisterComponents('GKO', [TPoytap]);
end;

end.
