unit jarjpeli;
{
  Jrjestmispeli.  Tarkoistus on animoida korttien jrjestmist
  algoritmeja opeteltaessa.

  Tekij:  Vesa Lapplainen
  Milloin: 17.1.1998

  Muutettu sum-masterista:
    5.11.1997/ Tanja Partanen ja Niina Riikonen

  Kntmisess mukaan tarvitaan:

    jarjpeli.pas   - tm tiedosto, ohjelman plomake
    jarjpeli.dfm   - tmn tiedoston lomake
    about.pas      - about dialogin ksittely
    about.dfm      - ja sen lomake
    laskuri.pas    - laskurikomponentti
    APakka.pas     - animoitu pakka
    kortti.pas     - kortit
    liikkuva.pas   - raami, joka iikuttaa komponentteja
    Pakka.pas      - peruspakka
    RaahausP.pas   - pakka, josta voidaan raahata kortteja
    raahattava.pas - raami, jonka avulla voidaan raahata komponentteja
    pelikort.res   - pelikorttien kuvat


  Tehtvi
  1) Mieti miten FormResizessa ei tavitssi ksitell "hiha"vakioita
  2) Tee metodi, jolla saadaan kaikki 3x- menut uncheckattua
     Millainen olisi metodi yleiskyttisen aliohjelmana?
  3) Tarvitseeko pytluokan ksitell pytpakkoja?
  4) Lis MessageBox, joka ilmoittaa jos peli menee lpi.
  5) siivoa_poytapakka muutettu siirtmn kortin jako pakkaan (Pakka)
     koske muuten uusi peli ei toiminut.  Miksi?
     Miten uusi peli saadaan toimimaan vaikka siivoaminen tehtisiin
     Varasto-pakkaan?
  6) Peri TPeliKortti-luokasta luokka TAPeliKortti (Animoitu kortti), joka
     kntyy "pihistmll".  "Pihistminen" saadaan aikaan esim.
     muuttamalla hitaasti kortin leveytt ensin ->0 ja sitten kntmll
     kortti ja muuttamalla taas leveys 0->alkup.leveyteen.
     Muuta ohjelma kyttmn "pihistvi" kortteja.
  7) Peri pakasta "pihistv" pakka, jossa kaikki kortit ovat kuvapuoli
     ylspin, mutta nkyvt pllimmist lukuunottamatta vain "vhsen"
     (property).
}
interface

uses
  Classes, SysUtils, Types,
{$ifdef CLX}
  QGraphics, QControls, QForms, QDialogs, QStdCtrls, QExtCtrls, QMenus, QTypes,
{$else}
  Windows, Messages,
  Graphics, Controls, Forms, Dialogs, StdCtrls, ExtCtrls, Menus,
{$endif}
  Pakka, APakka, Poyta, Poytap, Kortti, Liikkuva, Raahausp, laskuri;

type
  TFormJP = class(TForm)
    Panel1: TPanel;
    Poyta: TPoyta;
    Poytap1: TRaahausPakka;
    Poytap2: TRaahausPakka;
    Poytap3: TRaahausPakka;
    Poytap4: TRaahausPakka;
    Poytap5: TRaahausPakka;
    Poytap6: TRaahausPakka;
    Poytap7: TRaahausPakka;
    Poytap8: TRaahausPakka;
    Poytap9: TRaahausPakka;
    Poytap10: TRaahausPakka;
    Poytap11: TRaahausPakka;
    Poytap12: TRaahausPakka;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    New1: TMenuItem;
    Exit1: TMenuItem;
    Options1: TMenuItem;
    Help1: TMenuItem;
    Pakka: TAJakoPakka;
    About1: TMenuItem;
    ButtonPiilota: TButton;
    ButtonNayta: TButton;
    Varasto: TRaahausPakka;
    Hidden1: TMenuItem;
    PanelOsoittimet: TPanel;
    Ptr2: TLabel;
    Ptr1: TLabel;
    ButtonLeft: TButton;
    ButtonRight: TButton;
    LaskuriSiirto: TLaskuri;
    LaskuriVaihto: TLaskuri;
    Nollaa1: TMenuItem;
    Label1: TLabel;
    Label2: TLabel;
    Cards121: TMenuItem;
    Cards61: TMenuItem;
    Cards51: TMenuItem;
    Roskis: TRaahausPakka;
    Cards81: TMenuItem;
    Cards151: TMenuItem;
    CardsFull1: TMenuItem;
    RaahausPakka1: TRaahausPakka;
    RaahausPakka2: TRaahausPakka;
    RaahausPakka3: TRaahausPakka;
    Image1: TImage;
    procedure FormCreate(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure PakkaFull(sender: TPakka; i: Integer; k: TKortti);
    procedure About1Click(Sender: TObject);
    procedure ButtonPiilotaClick(Sender: TObject);
    procedure ButtonNaytaClick(Sender: TObject);
    procedure Hidden1Click(Sender: TObject);
    procedure Ptr2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure ButtonLeftClick(Sender: TObject);
    procedure VarastoInsert(sender: TPakka; i: Integer; k: TKortti);
    procedure P1Insert(sender: TPakka; i: Integer; k: TKortti);
    procedure P2Insert(sender: TPakka; i: Integer; k: TKortti);
    procedure JakoInsert(sender: TPakka; i: Integer; k: TKortti);
    procedure Nollaa1Click(Sender: TObject);
    procedure PanelOsoittimetMouseDown(Sender: TObject;
      Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
    procedure Cards51Click(Sender: TObject);
    procedure Image1Click(Sender: TObject);
  private
    FKortteja : integer;
    FPtr : TLabel;
    Fx   : Integer;
    p1,p2 : TPakka;
    FSaapuneita : integer;
    FTavoite : integer;
    procedure jaa_kortti(p:TPakka);
    procedure uusi_peli;
    procedure keraa_kortit;
    procedure siivoa_pakka(p:TPakka);
    procedure siirra_kortit;
    procedure piilota(p:TPakka);
    procedure Nayta(p:TPakka);
    procedure ShowCards(b:boolean);
    procedure TarkistaPaikka(p:TPakka);
    procedure DragArrive(o,w:TControl;data:integer);
    procedure TarkistaSuunta;
    procedure Nollaa;
    procedure SetPuoli(p:TPakka; puoli:TNakyy);
    procedure JaaKortit;
    procedure AloitaJako;
  public
  end;

var
  FormJP: TFormJP;

implementation

uses AboutJar,raahattava;

{$ifdef CLX}
{-$R *.xfm}  // muuta $R-muotoon jos haluat knt CLX:ll /mn
{$else}
{$R *.dfm}
{$endif}


procedure TFormJP.uusi_peli;
begin
  ShowCards(not Hidden1.Checked);
  if ( Pakka.Kortteja = 52 ) then begin JaaKortit; exit; end;
  keraa_kortit(); // Sekoita ja jaa tulee automaattisesti kun pakassa on
  siirra_kortit;  // 52 korttia!
end;

procedure TFormJP.FormCreate(Sender: TObject);
begin
  FKortteja := 0;
  Randomize;
  uusi_peli;                                                               // vl
{$ifdef CLX}
  Caption := Caption + ', CLX';
{$else}
  Caption := Caption + ', VCL';
{$endif}

end;

procedure TFormJP.jaa_kortti(p:TPakka);
begin
  if ( p.kortteja = 0 ) and ( p.Visible ) then begin
    p.OnInsert := JakoInsert;
    p.lisaa_kortti(Pakka.anna_kortti);
  end;
end;

procedure TFormJP.siivoa_pakka(p:TPakka);
begin
  if ( p.kortteja <> 0 ) then                                             
    Pakka.lisaa_kortti(p.anna_kortti);
end;

procedure TFormJP.keraa_kortit;
begin
  Poyta.ForEveryPakka(siivoa_pakka);
end;

procedure TFormJP.siirra_kortit;
begin
  Pakka.siirra(Varasto);
  Pakka.siirra(Roskis);
end;


procedure TFormJP.Exit1Click(Sender: TObject);
begin
  Close;
end;


procedure TFormJP.New1Click(Sender: TObject);
begin
  uusi_peli;
end;

procedure TFormJP.AloitaJako;
begin
  FSaapuneita := 0;
  FTavoite := Pakka.MaxKortteja-FKortteja;
  Poyta.ForEveryPakka(jaa_kortti);
  FTavoite := Pakka.MaxKortteja-Pakka.Kortteja;
end;

procedure TFormJP.JaaKortit;
begin
  Pakka.sekoita;
//  Pakka.Jarjesta;
  AloitaJako;
end;

procedure TFormJP.PakkaFull(sender: TPakka; i: Integer; k: TKortti);
begin
  JaaKortit;
end;

procedure TFormJP.About1Click(Sender: TObject);
begin
  AboutBox.ShowModal;
end;

procedure TFormJP.SetPuoli(p:TPakka; puoli:TNakyy);
begin
  if ( FKortteja > 0 ) then
    p.Visible := ( p.Left < FKortteja*p.Width )
  else
    p.Visible := ( p.Left + p.Width < Poyta.Width );
  p.Puoli := puoli;
end;

procedure TFormJP.Piilota(p:TPakka);
begin
  SetPuoli(p,selka);
end;

procedure TFormJP.Nayta(p:TPakka);
begin
  SetPuoli(p,kuva);
end;

procedure TFormJP.ShowCards(b:boolean);
begin
  if ( not b ) then begin
    Poyta.ForEveryPakka(piilota);
    ButtonPiilota.Visible := false;
    ButtonNayta.Visible := true;
    Varasto.Puoli := selka;
    Roskis.Puoli := selka;
    exit;
  end;
  Poyta.ForEveryPakka(nayta);
  ButtonPiilota.Visible := true;
  ButtonNayta.Visible := false;
  Varasto.Puoli := kuva;
  Roskis.Puoli := kuva;
end;

procedure TFormJP.ButtonPiilotaClick(Sender: TObject);
begin
  ShowCards(false);
end;

procedure TFormJP.ButtonNaytaClick(Sender: TObject);
begin
  ShowCards(true);
end;


procedure TFormJP.Hidden1Click(Sender: TObject);
begin
  Hidden1.Checked := not Hidden1.Checked;
end;

procedure TFormJP.TarkistaPaikka(p:TPakka);
begin
  if ( p.Left <= Fx ) and ( Fx < p.Left + p.Width ) then begin
    FPtr.FocusControl := p;
    FPtr.Parent := PanelOsoittimet;
    FPtr.Left := p.Left;
    FPtr.Top := 0;
  end;
end;

procedure TFormJP.TarkistaSuunta;
var pt : TPakka;
begin
  if ( not ( Ptr1.FocusControl is TPakka ) ) then exit;
  if (  not ( Ptr2.FocusControl is TPakka ) ) then exit;
  p1 := ( Ptr1.FocusControl as TPakka );
  p2 := ( Ptr2.FocusControl as TPakka );
  if Ptr2.Left < Ptr1.Left then begin
    pt := p1; p1 := p2; p2 := pt;
  end;
  ButtonLeft.Enabled := false;
  ButtonRight.Enabled := false;
  if ( p1.anna_arvo < p2.anna_arvo ) then ButtonLeft.Enabled := true;
  if ( p1.anna_arvo > p2.anna_arvo ) then ButtonRight.Enabled := true;
end;

procedure TFormJP.DragArrive(o,w:TControl;data:integer);
var pt: TPoint;
begin
  FPtr := o as TLabel;
  pt := ScreenToClient(o.ClientToScreen(Point(0,0)));
  Fx := pt.x + FPtr.Width div 2;
  Poyta.ForEveryPakka(TarkistaPaikka);
  TarkistaSuunta;
  LaskuriSiirto.Inc(1);
end;

procedure TFormJP.Ptr2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
  if ( Button <> mbLeft ) then exit;
  RaahaaXY(Sender as TControl,x,y,DragArrive,0);
end;

procedure TFormJP.ButtonLeftClick(Sender: TObject);
begin
  ButtonLeft.Enabled := false;
  ButtonRight.Enabled := false;
  Varasto.OnInsert := VarastoInsert;
  Varasto.lisaa_kortti(p1.Anna_kortti);
end;

procedure TFormJP.VarastoInsert(sender: TPakka; i: Integer; k: TKortti);
begin
  p1.OnInsert := P1Insert;
  p1.lisaa_kortti(p2.Anna_kortti);
end;

procedure TFormJP.P1Insert(sender: TPakka; i: Integer; k: TKortti);
begin
  p2.OnInsert := P2Insert;
  p2.lisaa_kortti(Varasto.Anna_kortti);
end;

procedure TFormJP.P2Insert(sender: TPakka; i: Integer; k: TKortti);
begin
  Varasto.OnInsert := nil;
  p1.OnInsert := nil;
  p2.OnInsert := nil;
  TarkistaSuunta;
  LaskuriVaihto.Inc(1);
end;

procedure TFormJP.JakoInsert(sender: TPakka; i: Integer; k: TKortti);
begin
  inc(Fsaapuneita);
  if FSaapuneita < FTavoite then exit;
  DragArrive(ptr1,nil,0);
  DragArrive(ptr2,nil,0);
  Nollaa;
end;

procedure TFormJP.Nollaa;
begin
  LaskuriSiirto.Count := 0;
  LaskuriVaihto.Count := 0;
end;


procedure TFormJP.Nollaa1Click(Sender: TObject);
begin
  Nollaa;
end;

procedure TFormJP.PanelOsoittimetMouseDown(Sender: TObject;
  Button: TMouseButton; Shift: TShiftState; X, Y: Integer);
begin
  if ( Button = mbLeft ) then begin
    Ptr1.Left := x - Ptr1.Width div 2;
    DragArrive(ptr1,nil,0);
  end;
  if ( Button = mbRight ) then begin
    Ptr2.Left := x - Ptr2.Width div 2;
    DragArrive(ptr2,nil,0);
  end;
end;

procedure TFormJP.Cards51Click(Sender: TObject);
begin
  FKortteja := (Sender as TMenuItem).Tag;
  Uusi_Peli;
end;

procedure TFormJP.Image1Click(Sender: TObject);
begin
  AloitaJako;
end;

end.
